package com.example.tdl.web;

import com.example.tdl.domain.dto.CommFeedback;
import com.example.tdl.domain.vo.AddAlarmLogVo;
import com.example.tdl.entity.AlarmLog;
import com.example.tdl.service.AlarmLogService;
import com.example.tdl.service.GatewayService;
import com.google.gson.Gson;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;


@RestController
@RequestMapping("/alarmLog")
public class AlarmLogController {
    private Logger logger= LoggerFactory.getLogger(AlarmLogController.class);

    Gson gson= new Gson();

    CommFeedback fb=new CommFeedback();

    @Autowired
    private AlarmLogService alarmLogServcie;

    @Autowired
    private GatewayService gatewayService;



    //新增报警消息
    @RequestMapping(value = "/addAlarmLog",method = RequestMethod.POST)
    public String addAlarmLog(@RequestBody String addAlarmLog){
        logger.info(addAlarmLog);
        AddAlarmLogVo addAlarmLogVo = gson.fromJson(addAlarmLog,AddAlarmLogVo.class);
        logger.info(System.currentTimeMillis()+"--------"+gson.toJson(addAlarmLogVo));
        if(StringUtils.isEmpty(addAlarmLogVo.getGsn())){
            fb.setCode(0);
            fb.setMessage("网关序列号不能为空");
        }
        if(StringUtils.isEmpty(addAlarmLogVo.getGtype())){
            fb.setCode(0);
            fb.setMessage("网关类型不能为空");
        }
        if(addAlarmLogVo.getAlarm()==null){
            fb.setCode(0);
            fb.setMessage("报警数据不能为空");
        }
        if(addAlarmLogVo.getTs() == null){
            fb.setCode(0);
            fb.setMessage("时间不能为空");
        }Map<Integer,String> map = new HashMap<>();
        map.put(0,"正常");
        map.put(1,"等于最大值");
        map.put(2,"不等于最大值");
        map.put(3,"过高");
        map.put(4,"过低");
        map.put(5,"未知");
        //根据gateway的信息获取线路信息
       String transportationNo =  gatewayService.getTransportationNo(addAlarmLogVo.getGsn(),addAlarmLogVo.getGtype());
        for(int i = 0;i<addAlarmLogVo.getAlarm().size();i++){
            String classify="";
            String desp = "";
            if(addAlarmLogVo.getAlarm().get(i).getAlias().contains("T")){
                desp = "温度" +map.get(addAlarmLogVo.getAlarm().get(i).getAlarmno());
                 classify = "1";
            } else if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("h")){
                desp = "湿度" +map.get(addAlarmLogVo.getAlarm().get(i).getAlarmno());
                 classify = "2";
            } else if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("a0")){
                desp = "震动" +map.get(addAlarmLogVo.getAlarm().get(i).getAlarmno());
                 classify = "3";
            } else if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("ta")){
                desp = "倾角" +map.get(addAlarmLogVo.getAlarm().get(i).getAlarmno());
                 classify = "4";
            }
//          else  if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("光爆")){
//            desp = "温度" +map.get(addAlarmLogVo.getAlarm().get(i).getAlarmno());
//                 classify = "5";
//            }
            else if(addAlarmLogVo.getAlarm().get(i).getDesp().contains("离线")){
                desp = addAlarmLogVo.getAlarm().get(i).getTdlsn()+"离线";
                classify = "6";
            }
            AlarmLog alarmLog = new AlarmLog(transportationNo,addAlarmLogVo.getAlarm().get(i).getTdlsn().replace("TDL-","").trim(),desp,addAlarmLogVo.getAlarm().get(i).getValue(),addAlarmLogVo.getAlarm().get(i).getTs()*1000,classify);
            int a = alarmLogServcie.addAlarmLog(alarmLog);
            if(a == 0){
                fb.setCode(0);
                fb.setMessage("添加失败");
            }else{
                fb.setCode(1);
                fb.setMessage("添加成功");
            }
        }
        return gson.toJson(fb);
    }
}
